from inspect import isfunction
import csv


def process_data(data, columns):
    output = [[]]

    for i in xrange(len(columns)):
        output[0].append(columns[i][1])

    for datum in data:
        new_line = []
        for column in columns:
            if isfunction(column[0]):
                new_line.append(column[0](datum))
            else:
                new_line.append(int(datum[column[0]]))
        output.append(new_line)

    return output


def filter_data(data, selector):
    return [item for item in data if selector(item)]
